//ģ˹Ϊ125
module wgn(clk,reset,en,state,noise);
    input   clk;
    input   reset;
    input   en;
    input   [1:0]   state;
    output  [8:0]   noise;

    reg     [8:0]   noise;
    reg     [249:0] state1;
    reg     [249:0] state2;
    reg     [5:0]   sum0,sum1,sum2,sum3,sum4,sum5,sum6,sum7,sum8;
    reg     [7:0]   sumA,sumB,sumC;

    wire    [249:0] Transmatrix1;
    wire    [249:0] Transmatrix2;
    wire    [249:0] left1;
    wire    [249:0] left2;
    wire    [249:0] right1;
    wire    [249:0] right2;
    wire    [249:0] up1;
    wire    [249:0] up2;
    wire    [249:0] down1;
    wire    [249:0] down2;

    wire    [2:0]   sum10,sum11,sum12,sum13,sum14,sum15,sum16,sum17,sum18,sum19;
    wire    [2:0]   sum1A,sum1B,sum1C,sum1D,sum1E,sum1F,sum1G,sum1H,sum1I,sum1J;
    wire    [2:0]   sum1K,sum1L,sum1M,sum1N,sum1O,sum1P,sum1Q,sum1R,sum1S,sum1T;
    wire    [2:0]   sum1U,sum1V,sum1W,sum1X,sum1Y,sum1Z;
    wire    [2:0]   sum20,sum21,sum22,sum23,sum24,sum25,sum26,sum27,sum28,sum29;
    wire    [2:0]   sum2A,sum2B,sum2C,sum2D,sum2E,sum2F,sum2G,sum2H,sum2I,sum2J;
    wire    [2:0]   sum2K,sum2L,sum2M,sum2N,sum2O,sum2P,sum2Q,sum2R,sum2S,sum2T;
    wire    [2:0]   sum2U,sum2V,sum2W,sum2X,sum2Y,sum2Z;
    wire    [4:0]   sum10x,sum11x,sum12x,sum13x,sum14x,sum15x,sum16x,sum17x,sum18x;
    wire    [4:0]   sum20x,sum21x,sum22x,sum23x,sum24x,sum25x,sum26x,sum27x,sum28x;
    wire    [9:0]   sum;

    assign  Transmatrix1    = 250'h004_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000;
    assign  Transmatrix2    = 250'h000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00400_00000_00000;
    assign  left1[249]      = 1'b0;
    assign  left1[248:0]    = state1[249:1];
    assign  left2[249]      = 1'b0;
    assign  left2[248:0]    = state2[249:1];
    assign  right1[0]       = 1'b0;
    assign  right1[249:1]   = state1[248:0];
    assign  right2[0]       = 1'b0;
    assign  right2[249:1]   = state2[248:0];
    assign  up1             = 250'h000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000;
    assign  up2             = state1;
    assign  down1           = state2;
    assign  down2           = 250'h000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000_00000;
    assign  sum             = add10(sumA,sumB,sumC);

    assign  sum10 = add3(state1[ 0],state1[ 1],state1[ 2],state1[ 3],state1[ 4],state1[ 5],state1[ 6]);
    assign  sum11 = add3(state1[ 7],state1[ 8],state1[ 9],state1[10],state1[11],state1[12],state1[13]);
    assign  sum12 = add3(state1[14],state1[15],state1[16],state1[17],state1[18],state1[19],state1[20]);
    assign  sum13 = add3(state1[21],state1[22],state1[23],state1[24],state1[25],state1[26],state1[27]);
    assign  sum14 = add3(state1[28],state1[29],state1[30],state1[31],state1[32],state1[33],state1[34]);
    assign  sum15 = add3(state1[35],state1[36],state1[37],state1[38],state1[39],state1[40],state1[41]);
    assign  sum16 = add3(state1[42],state1[43],state1[44],state1[45],state1[46],state1[47],state1[48]);
    assign  sum17 = add3(state1[49],state1[50],state1[51],state1[52],state1[53],state1[54],state1[55]);
    assign  sum18 = add3(state1[56],state1[57],state1[58],state1[59],state1[60],state1[61],state1[62]);
    assign  sum19 = add3(state1[63],state1[64],state1[65],state1[66],state1[67],state1[68],state1[69]);
    assign  sum1A = add3(state1[70],state1[71],state1[72],state1[73],state1[74],state1[75],state1[76]);
    assign  sum1B = add3(state1[77],state1[78],state1[79],state1[80],state1[81],state1[82],state1[83]);
    assign  sum1C = add3(state1[84],state1[85],state1[86],state1[87],state1[88],state1[89],state1[90]);
    assign  sum1D = add3(state1[91],state1[92],state1[93],state1[94],state1[95],state1[96],state1[97]);
    assign  sum1E = add3(state1[98],state1[99],state1[100],state1[101],state1[102],state1[103],state1[104]);
    assign  sum1F = add3(state1[105],state1[106],state1[107],state1[108],state1[109],state1[110],state1[111]);
    assign  sum1G = add3(state1[112],state1[113],state1[114],state1[115],state1[116],state1[117],state1[118]);
    assign  sum1H = add3(state1[119],state1[120],state1[121],state1[122],state1[123],state1[124],state1[125]);
    assign  sum1I = add3(state1[126],state1[127],state1[128],state1[129],state1[130],state1[131],state1[132]);
    assign  sum1J = add3(state1[133],state1[134],state1[135],state1[136],state1[137],state1[138],state1[139]);
    assign  sum1K = add3(state1[140],state1[141],state1[142],state1[143],state1[144],state1[145],state1[146]);
    assign  sum1L = add3(state1[147],state1[148],state1[149],state1[150],state1[151],state1[152],state1[153]);
    assign  sum1M = add3(state1[154],state1[155],state1[156],state1[157],state1[158],state1[159],state1[160]);
    assign  sum1N = add3(state1[161],state1[162],state1[163],state1[164],state1[165],state1[166],state1[167]);
    assign  sum1O = add3(state1[168],state1[169],state1[170],state1[171],state1[172],state1[173],state1[174]);
    assign  sum1P = add3(state1[175],state1[176],state1[177],state1[178],state1[179],state1[180],state1[181]);
    assign  sum1Q = add3(state1[182],state1[183],state1[184],state1[185],state1[186],state1[187],state1[188]);
    assign  sum1R = add3(state1[189],state1[190],state1[191],state1[192],state1[193],state1[194],state1[195]);
    assign  sum1S = add3(state1[196],state1[197],state1[198],state1[199],state1[200],state1[201],state1[202]);
    assign  sum1T = add3(state1[203],state1[204],state1[205],state1[206],state1[207],state1[208],state1[209]);
    assign  sum1U = add3(state1[210],state1[211],state1[212],state1[213],state1[214],state1[215],state1[216]);
    assign  sum1V = add3(state1[217],state1[218],state1[219],state1[220],state1[221],state1[222],state1[223]);
    assign  sum1W = add3(state1[224],state1[225],state1[226],state1[227],state1[228],state1[229],state1[230]);
    assign  sum1X = add3(state1[231],state1[232],state1[233],state1[234],state1[235],state1[236],state1[237]);
    assign  sum1Y = add3(state1[238],state1[239],state1[240],state1[241],state1[242],state1[243],state1[244]);
    assign  sum1Z = add3(state1[245],state1[246],state1[247],state1[248],state1[249],1'b0,1'b0);

    assign  sum20 = add3(state2[ 0],state2[ 1],state2[ 2],state2[ 3],state2[ 4],state2[ 5],state2[ 6]);
    assign  sum21 = add3(state2[ 7],state2[ 8],state2[ 9],state2[10],state2[11],state2[12],state2[13]);
    assign  sum22 = add3(state2[14],state2[15],state2[16],state2[17],state2[18],state2[19],state2[20]);
    assign  sum23 = add3(state2[21],state2[22],state2[23],state2[24],state2[25],state2[26],state2[27]);
    assign  sum24 = add3(state2[28],state2[29],state2[30],state2[31],state2[32],state2[33],state2[34]);
    assign  sum25 = add3(state2[35],state2[36],state2[37],state2[38],state2[39],state2[40],state2[41]);
    assign  sum26 = add3(state2[42],state2[43],state2[44],state2[45],state2[46],state2[47],state2[48]);
    assign  sum27 = add3(state2[49],state2[50],state2[51],state2[52],state2[53],state2[54],state2[55]);
    assign  sum28 = add3(state2[56],state2[57],state2[58],state2[59],state2[60],state2[61],state2[62]);
    assign  sum29 = add3(state2[63],state2[64],state2[65],state2[66],state2[67],state2[68],state2[69]);
    assign  sum2A = add3(state2[70],state2[71],state2[72],state2[73],state2[74],state2[75],state2[76]);
    assign  sum2B = add3(state2[77],state2[78],state2[79],state2[80],state2[81],state2[82],state2[83]);
    assign  sum2C = add3(state2[84],state2[85],state2[86],state2[87],state2[88],state2[89],state2[90]);
    assign  sum2D = add3(state2[91],state2[92],state2[93],state2[94],state2[95],state2[96],state2[97]);
    assign  sum2E = add3(state2[98],state2[99],state2[100],state2[101],state2[102],state2[103],state2[104]);
    assign  sum2F = add3(state2[105],state2[106],state2[107],state2[108],state2[109],state2[110],state2[111]);
    assign  sum2G = add3(state2[112],state2[113],state2[114],state2[115],state2[116],state2[117],state2[118]);
    assign  sum2H = add3(state2[119],state2[120],state2[121],state2[122],state2[123],state2[124],state2[125]);
    assign  sum2I = add3(state2[126],state2[127],state2[128],state2[129],state2[130],state2[131],state2[132]);
    assign  sum2J = add3(state2[133],state2[134],state2[135],state2[136],state2[137],state2[138],state2[139]);
    assign  sum2K = add3(state2[140],state2[141],state2[142],state2[143],state2[144],state2[145],state2[146]);
    assign  sum2L = add3(state2[147],state2[148],state2[149],state2[150],state2[151],state2[152],state2[153]);
    assign  sum2M = add3(state2[154],state2[155],state2[156],state2[157],state2[158],state2[159],state2[160]);
    assign  sum2N = add3(state2[161],state2[162],state2[163],state2[164],state2[165],state2[166],state2[167]);
    assign  sum2O = add3(state2[168],state2[169],state2[170],state2[171],state2[172],state2[173],state2[174]);
    assign  sum2P = add3(state2[175],state2[176],state2[177],state2[178],state2[179],state2[180],state2[181]);
    assign  sum2Q = add3(state2[182],state2[183],state2[184],state2[185],state2[186],state2[187],state2[188]);
    assign  sum2R = add3(state2[189],state2[190],state2[191],state2[192],state2[193],state2[194],state2[195]);
    assign  sum2S = add3(state2[196],state2[197],state2[198],state2[199],state2[200],state2[201],state2[202]);
    assign  sum2T = add3(state2[203],state2[204],state2[205],state2[206],state2[207],state2[208],state2[209]);
    assign  sum2U = add3(state2[210],state2[211],state2[212],state2[213],state2[214],state2[215],state2[216]);
    assign  sum2V = add3(state2[217],state2[218],state2[219],state2[220],state2[221],state2[222],state2[223]);
    assign  sum2W = add3(state2[224],state2[225],state2[226],state2[227],state2[228],state2[229],state2[230]);
    assign  sum2X = add3(state2[231],state2[232],state2[233],state2[234],state2[235],state2[236],state2[237]);
    assign  sum2Y = add3(state2[238],state2[239],state2[240],state2[241],state2[242],state2[243],state2[244]);
    assign  sum2Z = add3(state2[245],state2[246],state2[247],state2[248],state2[249],1'b0,1'b0);

    assign  sum10x = add5(sum10,sum11,sum12,sum13);
    assign  sum11x = add5(sum14,sum15,sum16,sum17);
    assign  sum12x = add5(sum18,sum19,sum1A,sum1B);
    assign  sum13x = add5(sum1C,sum1D,sum1E,sum1F);
    assign  sum14x = add5(sum1G,sum1H,sum1I,sum1J);
    assign  sum15x = add5(sum1K,sum1L,sum1M,sum1N);
    assign  sum16x = add5(sum1O,sum1P,sum1Q,sum1R);
    assign  sum17x = add5(sum1S,sum1T,sum1U,sum1V);
    assign  sum18x = add5(sum1W,sum1X,sum1Y,sum1Z);

    assign  sum20x = add5(sum20,sum21,sum22,sum23);
    assign  sum21x = add5(sum24,sum25,sum26,sum27);
    assign  sum22x = add5(sum28,sum29,sum2A,sum2B);
    assign  sum23x = add5(sum2C,sum2D,sum2E,sum2F);
    assign  sum24x = add5(sum2G,sum2H,sum2I,sum2J);
    assign  sum25x = add5(sum2K,sum2L,sum2M,sum2N);
    assign  sum26x = add5(sum2O,sum2P,sum2Q,sum2R);
    assign  sum27x = add5(sum2S,sum2T,sum2U,sum2V);
    assign  sum28x = add5(sum2W,sum2X,sum2Y,sum2Z);

    always@(posedge clk or posedge reset)
    begin
        if (reset == 1'b1)
        begin
            if (state == 2'b00)
            begin
                state1 <= 250'h4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4_4B4B4;
                state2 <= 250'hB4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B_B4B4B;
            end
            else if (state == 2'b01)
            begin
                state1 <= 250'h3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3_3C3C3;
                state2 <= 250'hC3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C_C3C3C;
            end
            else if (state == 2'b10)
            begin
                state1 <= 250'h696_69696_69696_69696_69696_69696_69696_69696_69696_69696_69696_69696_69696;
                state2 <= 250'h969_96969_96969_96969_96969_96969_96969_96969_96969_96969_96969_96969_96969;
            end
            else
            begin
                state1 <= 250'hF0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F_F0F0F;
                state2 <= 250'h0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0_0F0F0;
            end
        end
        else
        begin
            state1 <= (Transmatrix1 & state1) ^ left1 ^ right1 ^ up1 ^ down1;
            state2 <= (Transmatrix2 & state2) ^ left2 ^ right2 ^ up2 ^ down2;
        end
    end

    always@(posedge clk or posedge reset)
    begin
        if (reset == 1'b1)
        begin
            sum0 <= 6'd0;
            sum1 <= 6'd0;
            sum2 <= 6'd0;
            sum3 <= 6'd0;
            sum4 <= 6'd0;
            sum5 <= 6'd0;
            sum6 <= 6'd0;
            sum7 <= 6'd0;
            sum8 <= 6'd0;
        end
        else
        begin
            sum0 <= add6(sum10x,sum20x);
            sum1 <= add6(sum11x,sum21x);
            sum2 <= add6(sum12x,sum22x);
            sum3 <= add6(sum13x,sum23x);
            sum4 <= add6(sum14x,sum24x);
            sum5 <= add6(sum15x,sum25x);
            sum6 <= add6(sum16x,sum26x);
            sum7 <= add6(sum17x,sum27x);
            sum8 <= add6(sum18x,sum28x);
        end
    end

    always@(posedge clk or posedge reset)
    begin
        if (reset == 1'b1)
        begin
            sumA <= 8'd0;
            sumB <= 8'd0;
            sumC <= 8'd0;
        end
        else
        begin
            sumA <= add8(sum0,sum1,sum2);
            sumB <= add8(sum3,sum4,sum5);
            sumC <= add8(sum6,sum7,sum8);
        end
    end

    always@(posedge clk or posedge reset)
    begin
        if (reset == 1'b1)
            noise <= 9'd0;
        else
            noise <= (en) ? fix_point((sum - 10'd250)) : 9'd0;
    end

    function    [2:0]    add3;
        input   A,B,C,D,E,F,G;
    begin
        add3 = A + B + C + D + E + F + G;
    end
    endfunction

    function    [4:0]    add5;
        input   [2:0]    A,B,C,D;
    begin
        add5 = A + B + C + D;
    end
    endfunction

    function    [5:0]    add6;
        input   [4:0]    A,B;
    begin
        add6 = A + B;
    end
    endfunction

    function    [7:0]    add8;
        input   [5:0]    A,B,C;
    begin
        add8 = A + B + C;
    end
    endfunction

    function    [9:0]    add10;
        input   [7:0]    A,B,C;
    begin
        add10 = A + B + C;
    end
    endfunction

    function    [8:0] fix_point;
        input   [9:0] data;
    begin
        if (data[9] == 1'b0 && |data[8:8] == 1'b1)
            fix_point = {1'b0,{(8){1'b1}}};
        else if (data[9] == 1'b1 && &data[8:8] == 1'b0)
            fix_point = {1'b1,{(8){1'b0}}};
        else
            fix_point = data[8:0];
    end
    endfunction
endmodule
